<meta charset="utf-8" lang="fr">

**Introduction au mapping vidéo avec Splash**
[https://sat-metalab.gitlab.io/splash](https://sat-metalab.gitlab.io/splash)

<small><em><script>document.write(new Date().toLocaleDateString('fr-CA', {year: 'numeric', month: 'long', day: 'numeric'}));</script></em></small><br>
Marie-Ève Dumas & Emmanuel Durand

----------------

# Présentation

---

## [SAT]-Campus

* Département de formation de la **SAT**
* Mission : soutenir les artistes dans leur appropriation des nouvelles technologies
* Sphères d'activités :
    * Ateliers jeunesse
    * Visites scolaires
    * Formation continue
    * Formations privées et partenariats
    * ...
* Plus de 200 activités organisées en 2019-2020

---

## [SAT]-Metalab

* Laboratoire de recherche de la **SAT**
    * équipe d'environ 10 personnes développeurs/chercheurs
* Mission : créer des outils pour faciliter l'accès aux nouvelles technologies
* Thèmes de recherche : téléprésence, immersion, mapping vidéo, son spatialisé, ...
* Valorisation :
    * transfert technologique
    * communications scientifiques
    * logiciels libres (GPL, LGPL)
* [https://sat.qc.ca/recherche](https://sat.qc.ca/recherche)

---

## À propos de Splash

* Logiciel de mapping vidéo
    * capable de gérer un nombre (en théorie) illimité de projections
    * adapté pour déployer des espaces immersifs
    * flexible et scriptable en Python
    * capable de discuter avec tous les outils du Metalab ...
    * ... et d'autres, par NDI par exemple
    * développé sous licence GPL
* Peut être comparé à :
    * Photon, Green hippo pour la partie mapping vidéo
    * Blendy Dome VJ, Omnidome sans être limité aux dômes

---

# Démonstration de Splash

---

# Organisation du workshop

---

## Avant-midi

* Tour de table
* Problématiques liées au mapping vidéo
* Mise en place du matériel
* Éléments de scénographie immersive et création de la scène
* Présentation et prise en main de l'interface de Splash

---

## Après-midi

* Principes du calibrage géométrique et calibrage des dioramas
* Choix et application de contenu vidéo
* Présentation et prise en main de la correction de projection
* Principes et démonstration du mélange de vidéoprojections
* Conclusion

----------------

# Tour de table

----------------

# Probématiques liées au mapping vidéo

---

## Définition

> "Le vidéo mapping utilise des projecteurs courants, mais plutôt que de projeter sur un écran plat (...), la lumière est projetée sur une surface arbitraire (...)"
>  -- [http://projection-mapping.org/what-is-projection-mapping/](http://projection-mapping.org/what-is-projection-mapping/)

![](images/splash_sato.jpg)

---

## Projection vidéo sur géométrie arbitraire

![](images/realObjectWithVideo.jpg style="height: 11rem") ![](images/posture-interaction.png style="height: 11rem")

---

## Problèmes à résoudre avec un seul vidéoprojecteur

1. Alignement sur la surface de projection

2. Prise en compte des variations d'intensité lumineuse

---

## Alignement sur la surface de projection

![Maillage 3D aligné sur l'objet réel](images/realObjectWireframe.jpg style="height: 12rem")

---

## Prise en compte des variations d'intensité lumineuse

![Distance de la surface de projection](images/lambertian_sphere.png style="height: 12rem")


---

## Problèmes à résoudre avec un plusieurs vidéoprojecteurs

1. Alignement sur la surface de projection

2. Prise en compte des variations d'intensité lumineuse

3. Prise en compte des zones de chevauchement

4. Alignement des multiples projections entre elles

---

## Prise en compte des variations d'intensité lumineuse

![Différence de luminosité entre les projecteurs](images/probe_calibrated_blending.png style="height: 12rem")

---

## Prise en compte des zones de chevauchement

![Chevauchements des projections](images/semidome_uncalibrated.jpg style="height: 12rem")

---

## Alignement des multiples projections entre elles

![Projections alignées dans les zones de chevauchement](images/semidome_wireframe_no_blending.jpg style="height: 12rem")

---

# Mise en place du matériel

---

## Directives

1. Allumer le projecteur

2. Placer le projecteur pour couvrir la surface de projection

----------------

# Éléments de scénographie immersive

---

## Scénographie immersive

* dépendance du contenu vis à vis de l'espace

![](images/blender-dome.png style="height: 10rem") ![](images/bretez-julien.jpg style="height: 10rem")

---

## Scénographie immersive

* choix de la géométrie

![](images/foyer.jpg style="height: 11rem") ![](images/drawing-space.png style="height: 11rem")

---

## Scénographie immersive

* choix d'un point de vue privilégié

![](images/scenographie_projection_center.png style="height: 12rem")

----------------

# Création de la scène dans Blender

---

## Création de la scène dans Blender

![](images/blender_default_cube.png style="height: 14rem")


---

## Création de la scène dans Blender

Directives :

1. Dans la scène par défaut, sélectionner le cube
2. Éditer le cube, supprimer l'un des coins (vertices) supérieurs
3. Sélectionner tous les vertices restants (touche **A**)
4. Subdiviser le cube 3 fois : touche **W**, puis **Subdivide**
5. Se placer dans une vue latérale : touche **3** du pavé numérique
6. Générer les coordonnées de texture : touche **U**, puis **Sphere projection**
7. Exporter en format **OBJ** par le menu **File** > **Export** > **Wavefront (.obj)**

----------------

# Interface de Splash

---

## Vue d'ensemble de Splash

![](images/splash_multiview_gui.png style="height: 14rem")

---

## Onglets importants

* **Graph** : configuration du graphe de rendu
* **Meshes** : paramètres des maillages 3D
* **Medias** : paramètres des sources image/vidéo
* **Cameras** : calibrage des projecteurs (caméra virtuelles)

---

## Splash GUI

![](images/splash_gui_contours.png style="height: 18rem")

---

## Splash Graph

![](images/splash_graph_contours.png style="height: 18rem")

---

## Splash Meshes

![](images/splash_meshes_contours.png style="height: 18rem")

---

## Splash Medias

![](images/splash_medias_contours.png style="height: 18rem")

---

## Splash Cameras

![](images/splash_cameras_contours.png style="height: 18rem")

---

# Prise en main de Splash

----------------

## Directives

1. Ouvrir **Splash**
2. Afficher l'interface utilisateur avec **ctrl** + **Tab**
3. Dans l'onglet **Meshes**, sélectionner le premier (et seul) maillage
4. Charger le maillage du diorama en le sélectionner à l'aide du navigateur (bouton **...**)
5. Dans l'onglet **Graph**, configurer les sorties vidéos :
   ![](images/splash_graph.png)

----------------

# Principes du calibrage géométrique

---

## Principes du calibrage géométrique

Rappel des cas d'usage de Splash :

* transformation d'un espace complet en espace immersif
* utilisation conjointe de plusieurs projecteurs

-> on a besoin de connaître la configuration précise de l'espace de projection.

-> on considère que l'on a un modèle 3D fidèle de l'espace

---

## Principes du calibrage géométrique

On cherche à déterminer, pour chaque projecteur :

* sa position
* son orientation
* son champ de vision (sa focale)
* ses déformations optiques

---

## Principes du calibrage géométrique

Pour obtenir ces informations, une méthode consiste à associer des points 3D de l'objet réel avec des positions dans l'image 2D projetée.

![](images/cubes_calibration.png style="height: 12rem")

---

## Principes du calibrage géométrique

Idéalement, chaque point de l'image 2D doit être projeté précisément sur le point 3D associé de l'objet réel.

![](images/cubes_calibration_front.png style="height: 12rem")

---

## Principes du calibrage géométrique

En pratique les imprécisions font que ça ne sera pas le cas, et Splash cherche à réduire la distance entre ces paires de points

![](images/cubes_calibration_calibrated.png style="height: 12rem")

---

## Principes du calibrage géométrique

9 paramètres à déterminer :

* position : 3
* orientation : 3
* focale : 1
* centre optique : 2

-> 6 point permettent de déterminer une solution valide, 7 sont conseillés

----------------

# Calibrage des dioramas immersifs

---

## Directives

1. Aller dans l'onglet **Cameras**
2. Sélectionner la seconde caméra de la liste, la première étant dédiée à la visualisation de la scène 3D
3. Passer en vue filaire avec **ctrl** + **W**
3. Positionner les points :
   * **clic gauche** pour placer un point 3D sur un vertex
   * **shift** + **clic gauche** pour placer le point 2D cible
   * **ctrl** + **clic gauche** pour supprimer un point 3D
4. Appuyer sur **Calibrate camera**

---

## Résultat attendu

![](images/splash_camera_calibration.png style="height: 14rem")

---

# Application de contenu vidéo

---

## Directives

1. Aller dans l'onglet **Media**
2. Sélectionner le seul media présent
3. Changer son type en choisissant **video** dans le menu déroulant
4. Après avoir ouvert le navigateur (bouton **...**), aller dans **Video** et choisissez une des vidéos présentes
5. La vidéo sera chargée et jouera automatiquement en boucle

---

# Principe de la correction de projection

---

## Définition

> "Le warping est le processus de manipulation numérique d'une image de telle sorte que la majorité des formes représentées dans l'image ont été considérablement déformées"
>  -- [https://en.wikipedia.org/wiki/Image_warping](https://en.wikipedia.org/wiki/Image_warping)

![](images/splash_sato.jpg)

---

## Exemple

![](images/warp_exemple.png)

---

## Correction: Post-calibrage

1. Ajustements légers

2. Ajustements localisés

---

## Problèmes à résoudre

1. Correction de la distorsion

2. Correction d’alignement des zones de chevauchement

3. Surface de projection imparfaite

---

## Limitations

* Le warp ne permet pas d'intégrer des objets mobiles dans la scénographie
* Perte de résolution dans certaines zones déformées
* Si les points de warping sortent de la zone affichée, le blending peut être coupé...

---

## Dans Splash...

* Patches de Bézier
* Ajustement par points de contrôle

---

## Dans Splash...

![](images/warp_splash.png)

---

## Dans Splash...

![](images/warp_splash_deformed.png)

---

# Prise en main de la correction

----

## Directives

1. Aller dans l'onglet **Warps**
2. Sélectionner la première caméra
3. Choisisser la résolution du grillage
4. Ajuster le warp à l'aide des points de contrôle

---

# Principes du mélange de projections

---

## Principes du mélange de projections

* Lorsque deux projections sont superposées, la luminosité des éléments de la zone de superposition ne doit pas être doublée
* Méthode naïve : diviser par deux la puissance de projection dans la zone de chevauchement

![](images/blending_hard.png)

---

## Principes du mélange de projections

* Problème : la méthode naïve produit des artefacts en bordure de projection
* Méthode moins sensible aux approximations : faire intervenir un gradient d'intensité

![](images/blending_soft.png)

----------------

# Démonstration du mélange de projections

----------------

# Conclusion

----------------

# Usages alternatifs de Splash

---

## Calibrage automatique

[Calibrage automatique avec Calimiro](https://vimeo.com/499279721)

---

## Shape placement

![](images/shapes_placement.webm)

---------------

# Annexes

---

## Cas d'un projecteur fixé sur un rail

Cas simplifié : focale connue, pas de rotation, translation sur un seul axe

![](images/rail_camera_overview.png style="height: 12rem")

---

## Méthode d'optimisation mise en œuvre

-> Image vue du dessus, avec un graphe de l'erreur

-> définition minimum local

---

## Méthode d'optimisation mise en œuvre

-> Image vue du dessus d'un cas plus général, avec une courbe random qui a un minimum local

-> définition minimum global

---

## Méthode d'optimisation mise en œuvre

-> définition de la descente de gradient à partir des exemples précédents

La descente de gradient n'est pas une méthode algébrique et peut mener à trouver un minimum local.

-> il est donc possible de devoir lancer plusieurs optimisations pour obtenir le minimum global

---

# Descente de gradient dans le cas simplifié

-> Vidéo ou succession d'images illustrant l'optimisation

---

---
# Ressources

- https://fr.wikipedia.org/wiki/Mapping_vidéo
- https://projection-mapping.org/
- https://en.wikipedia.org/wiki/Image_warping
- http://paulbourke.net/dome/fisheyewarp/

<!-- Markdeep slides stuff -->
<script>
    markdeepSlidesOptions = {
        aspectRatio: 16 / 9,
        theme: 'simple',
        fontSize: 28,
        diagramZoom: 1.0,
        totalSlideNumber: false,
        progressBar: true,
        breakOnHeadings: false
    };
</script>
<link rel="stylesheet" href="markdeep-slides/markdeep-slides.css">
<script src="markdeep-slides/markdeep-slides.js"></script>

<!-- Markdeep stuff -->
<script>
    markdeepOptions = {
        tocStyle: 'none',
        detectMath: false,
        onLoad: function() {
            initSlides();
            loadMathJax();
        }
    };
</script>
<style class="fallback">body{visibility:hidden;white-space:pre;font-family:monospace}</style>
<script src="markdeep-slides/lib/markdeep/1.07/markdeep.min.js" charset="utf-8"></script>
<script>window.alreadyProcessedMarkdeep||(document.body.style.visibility="visible")</script>

<!-- MathJax stuff -->
<script type="text/x-mathjax-config">
    MathJax.Hub.Config({
        jax: ["input/TeX","output/SVG"],
        TeX: {
            equationNumbers: {autoNumber: "AMS"},
            extensions: ["color.js"]
        },
        SVG: {
            font: "TeX"
        }
    });
</script>
<script>
    var mathjaxUrl = "markdeep-slides/lib/mathjax/2.7.5/MathJax.js?config=TeX-MML-AM_SVG";
    function loadMathJax() {
        var script = document.createElement("script");
        script.src = mathjaxUrl;
        document.body.appendChild(script);
    }
</script>
